select
  an.numero
  , an.nome as nome
  , (current_date - lac.dtinicio) as del
  , (case catrep.cdcategoria when 1 then 'Ins.' when 2 then 'Imp.' when 3 then 'Ges.' when 4 then 'Vaz.' else '' end) as situacao_reprodutiva
  , (select count(*) from reproducao re where re.cdanimal = an.cdanimal and re.cdtiporeproducao in (1,2,3)
        and re.data > coalesce(ultpar.data, '1900-01-01')) as num_tent_ciclo_atual
  , (case when (ultev.diagnostico = 'P') then
        (ultev.dtpartoprovavel - cast((select valor from configuracao where nome = 'PeriodoDescanso') as integer))
        else null end) as data_secagem_prevista
  , g1.descricao as grupo_atual
  , '' as anotacao_1
  , antepenultle.pesototal as antepenultimo_leite
  , penultle.pesototal as penultimo_leite
  , ultle.pesototal as ultimo_leite
  , antepenultexa.valor as antepenultimo_exame
  , penultexa.valor as penultimo_exame
  , ultexa.valor as ultimo_exame
  , antepenultana.ccs as antepenultimo_ccs
  , penultana.ccs as penultimo_ccs
  , ultana.ccs as ultimo_ccs
from
  animal an
  join lactacao lac on lac.cdanimal = an.cdanimal and lac.dtfim is null
  left join reproducao ultpar on ultpar.cdreproducao =
    (select first 1 re.cdreproducao from reproducao re where re.cdanimal = an.cdanimal and re.cdtiporeproducao = 7 order by re.data desc)
  left join reproducao ultev on ultev.cdreproducao =
    (select first 1 re.cdreproducao from reproducao re where re.cdanimal = an.cdanimal and
        ((re.cdtiporeproducao in (1,2,3,7)) or (re.diagnostico is not null) or (re.cio in (1,2,3))) order by re.data desc)
  join categoria catrep on catrep.cdcategoria =
    (select creprodutiva from sp_categoriaanimal(current_date, 'cdanimal = ' || an.cdanimal))
  left join leite ultle on ultle.cdleite =
    (select first 1 re.cdleite from leite re where re.cdlactacao = lac.cdlactacao order by re.dtleite desc)
  left join leite penultle on penultle.cdleite =
    (select first 1 re.cdleite from leite re where re.cdlactacao = ultle.cdlactacao and re.dtleite < ultle.dtleite order by re.dtleite desc)
  left join leite antepenultle on antepenultle.cdleite =
    (select first 1 re.cdleite from leite re where re.cdlactacao = penultle.cdlactacao and re.dtleite < penultle.dtleite order by re.dtleite desc)
  left join exameanimal ultexa on ultexa.cdexameanimal =
    (select first 1 re.cdexameanimal from exameanimal re where re.cdanimal = lac.cdanimal and re.dtexame >= lac.dtinicio
        order by re.dtexame desc)
  left join exameanimal penultexa on penultexa.cdexameanimal =
    (select first 1 re.cdexameanimal from exameanimal re where re.cdanimal = ultexa.cdanimal and re.dtexame < ultexa.dtexame and
        re.dtexame > lac.dtinicio order by re.dtexame desc)
  left join exameanimal antepenultexa on antepenultexa.cdexameanimal =
    (select first 1 re.cdexameanimal from exameanimal re where re.cdanimal = penultexa.cdanimal and re.dtexame < penultexa.dtexame and
        re.dtexame > lac.dtinicio order by re.dtexame desc)
  left join analiseleite ultana on ultana.cdanaliseleite =
    (select first 1 re.cdanaliseleite from analiseleite re where re.cdanimal = lac.cdanimal and re.dtanaliseleite >= lac.dtinicio and
        re.ccs is not null order by re.dtanaliseleite desc)
  left join analiseleite penultana on penultana.cdanaliseleite =
    (select first 1 re.cdanaliseleite from analiseleite re where re.cdanimal = ultana.cdanimal and re.dtanaliseleite < ultana.dtanaliseleite
        and re.dtanaliseleite >= lac.dtinicio and re.ccs is not null order by re.dtanaliseleite desc)
  left join analiseleite antepenultana on antepenultana.cdanaliseleite =
    (select first 1 re.cdanaliseleite from analiseleite re where re.cdanimal = penultana.cdanimal and re.dtanaliseleite < penultana.dtanaliseleite
        and re.dtanaliseleite >= lac.dtinicio and re.ccs is not null order by re.dtanaliseleite desc)
  left join movgrupo m1 on m1.cdmovgrupo =
    (select first 1 re.cdmovgrupo from movgrupo re join movgrupoanimal rea on rea.cdmovgrupo = re.cdmovgrupo where
        rea.cdanimal = an.cdanimal and re.dtmovimentacao <= current_date order by re.dtmovimentacao desc)
  left join grupoanimal g1 on g1.cdgrupoanimal = m1.cdgrupoanimal
where
  an.dtbaixa is null
